Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your CAN Bricklet 2.0", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"can", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletCANV2\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Configure transceiver for loopback mode", "*)"}],
   RowBox[{"can", "@", RowBox[{"SetTransceiverConfiguration", "[", RowBox[{"1000000", ",", "625", ",", RowBox[{"\[IndentingNewLine]", "Tinkerforge`BrickletCANV2`TRANSCEIVERUMODEULOOPBACK"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for frame read callback", "*)"}],
   RowBox[{RowBox[{"FrameReadCB", "[", RowBox[{"sender_", ",", "frameType_", ",", "identifier_", ",", "data_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Module", "[", RowBox[{RowBox[{"{", "}"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"frameType", "==", "Tinkerforge`BrickletCANV2`FRAMEUTYPEUSTANDARDUDATA"}], ",", RowBox[{"Print", "[", "\"\<Frame Type: Standard Data\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"frameType", "==", "Tinkerforge`BrickletCANV2`FRAMEUTYPEUSTANDARDUREMOTE"}], ",", RowBox[{"Print", "[", "\"\<Frame Type: Standard Remote\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"frameType", "==", "Tinkerforge`BrickletCANV2`FRAMEUTYPEUEXTENDEDUDATA"}], ",", RowBox[{"Print", "[", "\"\<Frame Type: Extended Data\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"frameType", "==", "Tinkerforge`BrickletCANV2`FRAMEUTYPEUEXTENDEDUREMOTE"}], ",", RowBox[{"Print", "[", "\"\<Frame Type: Extended Remote\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Identifier: \>\"", "<>", RowBox[{"ToString", "[", "identifier", "]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Data (Length: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", RowBox[{"Length", "[", "data", "]"}], "]"}], "]"}], "<>", "\"\<): \>\"", "<>", RowBox[{"ToString", "[", "data", "]"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"can", "@", "FrameReadCallback"}], ",", "FrameReadCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Enable frame read callback", "*)"}],
   RowBox[{"can", "@", RowBox[{"SetFrameReadCallbackConfiguration", "[", "True", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Write standard data frame with identifier 1742 and 3 bytes of data", "*)"}],
   RowBox[{"can", "@", RowBox[{"WriteFrame", "[", RowBox[{"Tinkerforge`BrickletCANV2`FRAMEUTYPEUSTANDARDUDATA", ",", "1742", ",", RowBox[{"{", RowBox[{"42", ",", "23", ",", "17"}], "}"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"can", "@", RowBox[{"SetFrameReadCallbackConfiguration", "[", "False", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "can", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
