Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your Motorized Linear Poti Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"mlp", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletMotorizedLinearPoti\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for position reached callback", "*)"}],
   RowBox[{RowBox[{"PositionReachedCB", "[", RowBox[{"sender_", ",", "position_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Position: \>\"", "<>", RowBox[{"ToString", "[", "position", "]"}]}], "]"}], RowBox[{"(*", "Range: 0 to 100", "*)"}]}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"mlp", "@", "PositionReachedCallback"}], ",", "PositionReachedCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Move slider smooth to the middle", "*)"}],
   RowBox[{"mlp", "@", RowBox[{"SetMotorPosition", "[", RowBox[{"50", ",", "Tinkerforge`BrickletMotorizedLinearPoti`DRIVEUMODEUSMOOTH", ",", "False"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "mlp", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
