Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your One Wire Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"ow", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletOneWire\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"ow", "@", RowBox[{"WriteCommand", "[", RowBox[{"0", ",", "78"}], "]"}], RowBox[{"(*", "WRITE SCRATCHPAD", "*)"}]}],
   RowBox[{"ow", "@", RowBox[{"Write", "[", "0", "]"}], RowBox[{"(*", "ALARM H (unused)", "*)"}]}],
   RowBox[{"ow", "@", RowBox[{"Write", "[", "0", "]"}], RowBox[{"(*", "ALARM L (unused)", "*)"}]}],
   RowBox[{"ow", "@", RowBox[{"Write", "[", "127", "]"}], RowBox[{"(*", "CONFIGURATION: 12-bit mode", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Read temperature 10 times", "*)"}],
   RowBox[{"For", "[", RowBox[{RowBox[{"i", "=", "0"}], ",", RowBox[{"i", "<", "10"}], ",", RowBox[{"i", "++"}], ",", RowBox[{"\[IndentingNewLine]", "ow", "@", RowBox[{"WriteCommand", "[", RowBox[{"0", ",", "68"}], "]"}], ";", RowBox[{"(*", "CONVERT T (start temperature conversion)", "*)"}], "\[IndentingNewLine]", RowBox[{"Pause", "[", "1", "]"}], ";", RowBox[{"(*", "Wait for conversion to finish", "*)"}], "\[IndentingNewLine]", "ow", "@", RowBox[{"WriteCommand", "[", RowBox[{"0", ",", "190"}], "]"}], ";", RowBox[{"(*", "READ SCRATCHPAD", "*)"}], "\n", "\[IndentingNewLine]", "tLow", "=", "0", ";", "tHigh", "=", "0", ";", "status", "=", "0", ";", "\[IndentingNewLine]", "ow", "@", RowBox[{"Read", "[", RowBox[{"tLow", ",", "status"}], "]"}], ";", "\[IndentingNewLine]", "ow", "@", RowBox[{"Read", "[", RowBox[{"tHigh", ",", "status"}], "]"}], ";", "\[IndentingNewLine]", "temperature", "=", RowBox[{"BitOr", "[", RowBox[{"tLow", ",", RowBox[{"BitShiftLeft", "[", RowBox[{"tHigh", ",", "8"}], "]"}]}], "]"}], ";", "\n", "\[IndentingNewLine]", RowBox[{"(*", "Negative 12-bit values are sign-extended to 16-bit two's complement", "*)"}], "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"temperature", ">", RowBox[{"BitShiftLeft", "[", RowBox[{"1", ",", "12"}], "]"}]}], ",", RowBox[{"temperature", "=", "temperature", "-", RowBox[{"BitShiftLeft", "[", RowBox[{"1", ",", "16"}], "]"}]}]}], "]"}], ";", "\n", "\[IndentingNewLine]", RowBox[{"(*", "12 bit-mode measures in units of 1/16\.b0C", "*)"}], "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Temperature: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", RowBox[{"Quantity", "[", RowBox[{"temperature", ",", "\"\<\.b0C/16\>\""}], "]"}], "]"}], "]"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "ow", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
