Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"(*", "For this example connect the RX1 and TX pin to receive the send message", "*)"}],
   RowBox[{"
"}],
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your RS232 Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"rs232", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletRS232\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Convert string to char array with length 60,as needed by write", "*)"}],
   RowBox[{RowBox[{"StringToCharList", "[", "message_", "]"}], ":=", RowBox[{"PadRight", "[", RowBox[{RowBox[{"ToCharacterCode", "[", "message", "]"}], ",", "60", ",", "0"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Assume that the message consists of ASCII characters and", "*)"}],
   RowBox[{"(*", "convert it from an array of chars to a string", "*)"}],
   RowBox[{RowBox[{"CharListToString", "[", RowBox[{"message_", ",", "length_"}], "]"}], ":=", RowBox[{"StringTake", "[", RowBox[{RowBox[{"FromCharacterCode", "[", "message", "]"}], ",", "length"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Callback function for read callback ", "*)"}],
   RowBox[{RowBox[{"ReadCB", "[", RowBox[{"sender_", ",", "message_", ",", "length_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Print", "[", RowBox[{"\"\<Message (Length: \>\"", "<>", RowBox[{"ToString", "[", RowBox[{"N", "[", "length", "]"}], "]"}], "<>", "\"\<): \>\"", "<>", "\[IndentingNewLine]", RowBox[{"CharListToString", "[", RowBox[{"message", ",", "length"}], "]"}]}], "]"}]}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"rs232", "@", "ReadCallback"}], ",", "ReadCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Enable read callback", "*)"}],
   RowBox[{"rs232", "@", RowBox[{"EnableReadCallback", "[", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Write ", "\"\<test\>\"", " string", "*)"}],
   RowBox[{"message", ":=", "\"\<test\>\""}],
   RowBox[{"(*", "FIXME: This call crashes Mono with a SIGSEGV, no clue why", "*)"}],
   RowBox[{"rs232", "@", RowBox[{"Write", "[", RowBox[{RowBox[{"StringToCharList", "[", "message", "]"}], ",", RowBox[{"StringLength", "[", "message", "]"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "rs232", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
