Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your Servo Bricklet 2.0", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"s", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletServoV2\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Use position reached callback to swing back and forth", "*)"}],
   RowBox[{RowBox[{"PositionReachedCB", "[", RowBox[{"sender_", ",", "servoChannel_", ",", "position_"}], "]"}], ":=", "\[IndentingNewLine]", RowBox[{"Module", "[", RowBox[{RowBox[{"{", "}"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"position", "==", "9000"}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"Print", "[", "\"\<Position: 90\.b0, going to -90\.b0\>\"", "]"}], ";", "\[IndentingNewLine]", "sender", "@", RowBox[{"SetPosition", "[", RowBox[{"servoChannel", ",", RowBox[{"-", "9000"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}], ";", "\[IndentingNewLine]", RowBox[{"If", "[", RowBox[{RowBox[{"position", "==", RowBox[{"-", "9000"}]}], ",", RowBox[{"\[IndentingNewLine]", RowBox[{"Print", "[", "\"\<Position: -90\.b0, going to 90\.b0\>\"", "]"}], ";", "\[IndentingNewLine]", "sender", "@", RowBox[{"SetPosition", "[", RowBox[{"servoChannel", ",", "9000"}], "]"}], "\[IndentingNewLine]"}]}], "]"}], "\[IndentingNewLine]"}]}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"AddEventHandler", "[", RowBox[{RowBox[{"s", "@", "PositionReachedCallback"}], ",", "PositionReachedCB"}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Enable position reached callback", "*)"}],
   RowBox[{"s", "@", RowBox[{"SetPositionReachedCallbackConfiguration", "[", RowBox[{"0", ",", "True"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Set velocity to 100\.b0/s. This has to be smaller or equal to the", "*)"}],
   RowBox[{"(*", "maximum velocity of the servo you are using, otherwise the position", "*)"}],
   RowBox[{"(*", "reached callback will be called too early", "*)"}],
   RowBox[{"s", "@", RowBox[{"SetMotionConfiguration", "[", RowBox[{"0", ",", "10000", ",", "500000", ",", "500000"}], "]"}]}],
   RowBox[{"s", "@", RowBox[{"SetPosition", "[", RowBox[{"0", ",", "9000"}], "]"}]}],
   RowBox[{"s", "@", RowBox[{"SetEnable", "[", RowBox[{"0", ",", "True"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"Input", "[", "\"\<Click OK to exit\>\"", "]"}],
   RowBox[{"
"}],
   RowBox[{"s", "@", RowBox[{"SetEnable", "[", RowBox[{"0", ",", "False"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "s", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
